/*
Determin prin programare dinamica cea mai mare suma care se poate obtine
plecand dintr-un varf al triunghilui, posibilitatile de miscare fiind doar
in jos si pe orizontala (la stanga sau la dreapta pozitiei curente).
Deoarece orice varf poate fi varf de start, matreicea se roteste
si se aplica algoritmul de 3 ori, retinand doar varianta optima

Eliminand comentariile din program, se obtine si drumul optim
*/

#include <fstream.h>
#include <iomanip.h>
#define NMAX 61

void Afisare();
void Citire();
void RotireCeas();
void Suma();

unsigned char a[NMAX][2*NMAX+1];
//int t[NMAX][2*NMAX+1];
long s[NMAX][2*NMAX+1];
long n, tmax, smax, tmp;

void main()
{
  Citire();                       //citesc datele de intrare
  for(int Rot=1; Rot<=3; Rot++)   //plec pe rand din cele 3 varfuri
   {
    Suma();
    if (smax<s[0][0])  {smax=s[0][0]; tmax=tmp;} //calculez suma
    RotireCeas();                 //rotesc cladirea
   }
  Afisare();
}

void Citire()
{
  ifstream f("8.in");
  int x;
  f>>n;
  for (int l=0;l<n;l++)
       for(int c=0; c<2*l+1; c++) {f>>x; a[l][c]=x;};
  f.close();
}

void Afisare()
{ ofstream g("8.out");
//  int i, j, k;
   g<<smax<<endl<<tmax<<endl;
/*  i=0; j=0;
  while (t[i][j]!=-1)
	{
	g<<i<<' '<<j<<' '<<a[i][j]<<endl;
	if (t[i][j]==j)
	   {i++; j++;}
	   else
	if (t[i][j]<j)
	      {
	      for (k=j-1; k>t[i][j]; k--)
		  g<<i<<' '<<k<<' '<<a[i][k]<<endl;
	      j=k;
	      }
              else
              if (t[i][j]>j)
                    {for (k=j+1; k<t[i][j]; k++)
                    g<<i<<' '<<k<<' '<<a[i][k]<<endl;
              j=k;}
        }*/
  g.close();
}

void Suma()
{
long sp, timp[NMAX][2*NMAX+1];
int l, k, i;
for (l=0; l<=n; l++)
    for (i=0; i<=2*l; i++) {s[l][i]=timp[l][i]=0;
    //t[l][i]=0;
    }
//for (i=0; i<2*l+1; i++) t[l][i]=-1;
for (l=n-1; l>0; l--)
    {
    for (i=0; i<2*l+1; i+=2)
	{s[l][i]= a[l][i]+s[l+1][i+1];//+(s[l+1][i]>s[l+1][i+2]?s[l+1][i]:s[l+1][i+2]);
	 //t[l][i]=i;
	 timp[l][i]=1+timp[l+1][i+1];
	 };
    for (i=1; i<2*l; i+=2)
	{
	s[l][i]=a[l][i];
	sp=a[l][i];
        //t[l][i]=-1;
        timp[l][i]=1;
	for (k=i-1; k>=0; k-=2,sp+=a[l][k+1]+a[l][k+2]) //merg in stanga
	    if (s[l][i]<s[l][k]+sp)
		{s[l][i]=s[l][k]+sp;
                //t[l][i]=k;
                timp[l][i]=i-k+1+timp[l+1][k+1];}
	sp=a[l][i];
	for (k=i+1; k<2*l+1; k+=2, sp+=a[l][k-1]+a[l][k-2]) //merg in dreapta
	     if (s[l][i]<s[l][k]+sp)
		{s[l][i]=s[l][k]+sp;
                //t[l][i]=k;
                timp[l][i]=k-i+1+timp[l+1][k+1];}
	}
    }
s[0][0]=a[0][0]+a[1][1]+(s[1][0]>s[1][2]?s[1][0]:s[1][2]);
//t[0][0]=0;
tmp=1+timp[1][1];
/* bun pentru debug
ofstream fs("sum.out");
int nrs=80;
for (l=0; l<n; nrs-=4,l++)
    {fs<<setw(nrs)<<' ';
    for (i=0; i<2*l+1; i++)
	fs<<setw(4)<<a[l][i];
    fs<<endl;
    }

for (l=0, nrs=80; l<n; nrs-=4,l++)
    {fs<<setw(nrs)<<' ';
    for (i=0; i<2*l+1; i++)
	fs<<setw(6)<<s[l][i];
    fs<<endl;
    }
for (l=0, nrs=80; l<n; nrs-=4,l++)
    {fs<<setw(nrs)<<' ';
    for (i=0; i<2*l+1; i++)
	fs<<setw(6)<<t[l][i];
    fs<<endl;
    }

fs.close(); */
}

void RotireCeas()
{
  int b[NMAX][2*NMAX+1];               //pentru a pleca din alt
  b[0][0]=a[n-1][0];                         //varf, "rotesc" cladirea
  for(int l=1;l<n;l++)                       //si plec, in acest fel,
    for(int c=0;c<2*l+1;c++)                 //tot din a[0][0]
      b[l][c]=a[n-(c/2+1)][2*l-c];           //rotirea o fac utilizand
  for(l=0;l<n;l++)                           //un tablou auxiliar
    for(int c=0;c<2*l+1;c++) a[l][c]=b[l][c];//alocat pe stiva
}
